CAD二次开发——填充

    

            图案填充
            Database db = HostApplicationServices.WorkingDatabase;
            ObjectIdCollection objIds = new ObjectIdCollection();
            using (Transaction trans = db.TransactionManager.StartTransaction())
            {
                BlockTable bt = trans.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
                BlockTableRecord btr = trans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
                Circle circle = new Circle(new Point3d(0, 0, 0), new Vector3d(0, 0, 1), 100);
                ObjectId objid = btr.AppendEntity(circle);
                objIds.Add(objid);
                trans.AddNewlyCreatedDBObject(circle, true);
                Hatch hatch = new Hatch();
                hatch.PatternScale = 5;
                //设置背景色
                hatch.BackgroundColor = Color.FromRgb(19, 48, 236);
                //设置填充图案颜色
                hatch.ColorIndex = 10;
                hatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI32");
                btr.AppendEntity(hatch);
                trans.AddNewlyCreatedDBObject(hatch, true);
                hatch.PatternAngle = Math.PI / 4;
                hatch.Associative = true;
                hatch.AppendLoop(HatchLoopTypes.Outermost, objIds);
                hatch.EvaluateHatch(true);
                trans.Commit();
            }

 

  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值